﻿using LawFirmContracts.BindingModels;
using LawFirmContracts.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LawFirmContracts.BusinessLogicContracts
{
    public interface IReportLogic
    {
        /// Получение списка компонент с указанием, в каких изделиях используются
        List<ReportDocumentBlankViewModel> GetDocumentBlanks();
        /// Получение списка заказов за определенный период
        List<ReportOrdersViewModel> GetOrders(ReportBindingModel model);
        /// Сохранение компонент в файл-Word
        void SaveDocumentsToWordFile(ReportBindingModel model);
        /// Сохранение компонент с указаеним продуктов в файл-Excel
        void SaveProductComponentToExcelFile(ReportBindingModel model);
        /// Сохранение заказов в файл-Pdf
        void SaveOrdersToPdfFile(ReportBindingModel model);
        // Сохранение магазинов в файл-Word
        void SaveShopsToWordFile(ReportBindingModel model);
        void SaveShopDocumentsToExcelFile(ReportBindingModel model);
        List<ReportShopDocumentsViewModel> GetShopDocuments(); 
        List<ReportDateOrdersViewModel> GetDateOrders();
        void SaveDateOrdersToPdfFile(ReportBindingModel model);
    }
}
