﻿using LawFirmContracts.BindingModels;
using LawFirmContracts.ViewModels;
using LawFirmDataModels.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Threading.Tasks;
using static System.Formats.Asn1.AsnWriter;

namespace LawFirmListImplements.Models
{
    public class Shop : IShopModel
    {
        public int Id { get; private set; }

        public string Name { get; private set; } = string.Empty;

        public string Adress { get; private set; } = string.Empty;

        public DateTime OpeningDate { get; private set; }

        public int MaxCountDocuments { get; private set; }

        public Dictionary<int, (IDocumentModel, int)> ShopDocuments { get; private set; } = new();

        public static Shop? Create (ShopBindingModel model)
        {
            if (model == null)
            {
                return null;
            }
            return new Shop()
            {
                Id = model.Id,
                Name = model.Name,
                Adress = model.Adress,
                OpeningDate = model.OpeningDate,
                MaxCountDocuments = model.MaxCountDocuments,
                ShopDocuments = new()
            };
        }

        public void Update(ShopBindingModel? model)
        {
            if (model == null)
            {
                return;
            }
            Name = model.Name;
            Adress = model.Adress;
            OpeningDate = model.OpeningDate;
            ShopDocuments = model.ShopDocuments;
            MaxCountDocuments= model.MaxCountDocuments;
        }

        public ShopViewModel GetViewModel => new()
        {
            Id = Id,
            Name = Name,
            Adress = Adress,
            OpeningDate = OpeningDate,
            ShopDocuments = ShopDocuments,
            MaxCountDocuments = MaxCountDocuments
        };

        
    }
}
